pthbs

Packaging Through Hashed Build Scripts
git clone https://ccx.te2000.cz/git/pthbs
Log | Files | Refs | Submodules | README

popt (3114B)


      1 #!/usr/bin/env pthbs-build
      2 #+musl-cross-make.65f98305f5666435bf0c6b9ccedffae2179ff1b3286752756886f760cf7771d2
      3 #+gnu-make.782c9e6625fd7420e2cd38b847afed19db3b3844cae8a0426a0dbf73e10d78e5
      4 #+busybox.e60885fe93ee85c01831673bb29f0e62a64903f4ce3094e3dc35bc8ec8887ad9
      5 #+busybox-diffutils.4f5a07b29246414b77a7d71b103263af8f1249d75ddcbd9864e00def3d6feded
      6 #+m4.d61a4ef6e5ca207e24ed8bbbd9931e1e0ac2359ed5aae4e384b49d71401b4840
      7 #@untar:-z:sha256:c25a4838fc8e4c1c8aacb8bd620edb3084a3d63bf8987fdad3ca2758c63240f9:.
      8 
      9 build_env_static() {
     10 	export LD_LIBRARY_PATH="$pthbs_build_environment/library"
     11 	export CPATH="$pthbs_build_environment/include"
     12 	export LDFLAGS="-static -L$pthbs_build_environment/library $LDFLAGS"
     13 }
     14 autotools_config() {
     15 	prefix=/versions/$pthbs_package
     16 	./configure -C \
     17 		--prefix="$prefix" \
     18 		--build="$(${CC:-gcc} -dumpmachine)" \
     19 		--bindir="$prefix/command" \
     20 		--sbindir="$prefix/command" \
     21 		--infodir="$prefix/info" \
     22 		--localedir="$prefix/locale" \
     23 		--mandir="$prefix/man" \
     24 		--libdir="$prefix/library" \
     25 		--docdir="$prefix/doc/popt" \
     26 		--datadir="$prefix/data" \
     27 		--datarootdir="$prefix/data" \
     28 		--localstatedir='/var/pthbs' \
     29 		"$@"
     30 
     31 }
     32 
     33 autotools() {
     34 	cd "$1"
     35 	shift
     36 	autotools_config "$@"
     37 	make -j${JOBS:-1} -l$((1+${JOBS:-1}))
     38 	make DESTDIR="$pthbs_destdir" install
     39 }
     40 
     41 autotools_static() {
     42 	build_env_static
     43 	autotools "$@" --enable-static --disable-shared
     44 }
     45 check_static() {
     46 	local exe || true
     47 	exe=$pthbs_destdir/'/versions'/$pthbs_package/$1
     48 	if ! test -f $exe; then
     49 		printf '%s\n' "Error: file '$1' doesn't exist!"
     50 		exit 1
     51 	fi
     52 	interp_info=$(readelf --string-dump=.interp "$exe") || exit $?
     53 	if test x '!=' "x$interp_info"; then
     54 		printf '%s\n' "Error: '$1' is a dynamic binary!"
     55 		exit 1
     56 	fi
     57 }
     58 
     59 autotools_static popt-1.19 --disable-nls
     60 
     61 
     62 cd "$pthbs_destdir/versions/$pthbs_package"
     63 find -type d -o -print | awk -F/ '
     64 BEGIN {
     65 	x["./include/popt.h"]=1
     66 	x["./library/libpopt.a"]=1
     67 }
     68 
     69 function r1(s) {
     70 	sub("^[.]/[^/]*", ".", s)
     71 	return s
     72 }
     73 function s1(repl, s) {
     74 	sub("^[.]/[^/]*", "./"repl, s)
     75 	return s
     76 }
     77 function link(src) {
     78 	x[$0]=0
     79 	printf "%s\t%s\n", $0, src
     80 	printf "genlinks >>%s\t%s<<\n", $0, src >>"/dev/stderr"
     81 }
     82 $1!="."{exit 1}
     83 
     84 
     85 $2 == "command" { link($0); next }
     86 $2 == "bin" { link(s1("command", $0)); next }
     87 
     88 $2 == "library.so" { link($0); next }
     89 $2 == "library" { link($0); next }
     90 $2 == "lib" && $NF ~ /\.l?a$/ { link(s1("library", $0)); next }
     91 $2 == "lib" && $NF ~ /\.so(|\..*)$/ { link(s1("library.so", $0)); next }
     92 
     93 $2 == "share" && $3 ~ /^(info|man|doc|icons|terminfo)$/ { link(r1($0)); next }
     94 
     95 $2 == "man" { link($0); next }
     96 $2 == "info" { link($0); next }
     97 $2 == "doc" { link($0); next }
     98 $2 == "icons" { link($0); next }
     99 $2 == "terminfo" { link($0); next }
    100 $2 == "data" { link($0); next }
    101 $2 == "include" { link($0); next }
    102 
    103 { printf "genlinks ##%s## skipped\n", $0 >>"/dev/stderr" }
    104 
    105 END {
    106 	for(fname in x) { printf "DEBUG: x[\"%s\"]=\"%s\"\n", fname, x[fname] >"/dev/stderr" }
    107 	for(fname in x) {
    108 		if(x[fname]) {
    109 			printf "ERROR: missing expected file \"%s\"\n", fname >"/dev/stderr"
    110 			exit 3
    111 		}
    112 	}
    113 }' >.install-links.new
    114 mv .install-links.new .install-links